deps.mk 21 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612
  1. # Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps clean-tmp-deps.log
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. # External "early" plugins (see core/plugins.mk for regular plugins).
  17. # They both use the core_dep_plugin macro.
  18. define core_dep_plugin
  19. -include $(DEPS_DIR)/$(1)
  20. $(DEPS_DIR)/$(1): $(DEPS_DIR)/$(2) ;
  21. endef
  22. DEP_EARLY_PLUGINS ?=
  23. $(foreach p,$(DEP_EARLY_PLUGINS),\
  24. $(eval $(if $(findstring /,$p),\
  25. $(call core_dep_plugin,$p,$(firstword $(subst /, ,$p))),\
  26. $(call core_dep_plugin,$p/early-plugins.mk,$p))))
  27. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  28. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  29. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  30. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  31. LOCAL_DEPS_DIRS = $(foreach a,$(LOCAL_DEPS),$(if $(wildcard $(APPS_DIR)/$(a)),$(APPS_DIR)/$(a)))
  32. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  33. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  34. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  35. ifeq ($(ERL_LIBS),)
  36. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  37. else
  38. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  39. endif
  40. endif
  41. export ERL_LIBS
  42. export NO_AUTOPATCH
  43. # Verbosity.
  44. dep_verbose_0 = @echo " DEP " $(1);
  45. dep_verbose_2 = set -x;
  46. dep_verbose = $(dep_verbose_$(V))
  47. # Core targets.
  48. apps:: $(ALL_APPS_DIRS) clean-tmp-deps.log
  49. ifeq ($(IS_APP)$(IS_DEP),)
  50. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  51. endif
  52. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  53. # Create ebin directory for all apps to make sure Erlang recognizes them
  54. # as proper OTP applications when using -include_lib. This is a temporary
  55. # fix, a proper fix would be to compile apps/* in the right order.
  56. ifndef IS_APP
  57. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  58. mkdir -p $$dep/ebin; \
  59. done
  60. endif
  61. # at the toplevel: if LOCAL_DEPS is defined with at least one local app, only
  62. # compile that list of apps. otherwise, compile everything.
  63. # within an app: compile all LOCAL_DEPS that are (uncompiled) local apps
  64. $(verbose) set -e; for dep in $(if $(LOCAL_DEPS_DIRS)$(IS_APP),$(LOCAL_DEPS_DIRS),$(ALL_APPS_DIRS)) ; do \
  65. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  66. :; \
  67. else \
  68. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  69. $(MAKE) -C $$dep IS_APP=1; \
  70. fi \
  71. done
  72. clean-tmp-deps.log:
  73. ifeq ($(IS_APP)$(IS_DEP),)
  74. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  75. endif
  76. ifneq ($(SKIP_DEPS),)
  77. deps::
  78. else
  79. deps:: $(ALL_DEPS_DIRS) apps clean-tmp-deps.log
  80. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  81. $(verbose) set -e; for dep in $(ALL_DEPS_DIRS) ; do \
  82. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  83. :; \
  84. else \
  85. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  86. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  87. $(MAKE) -C $$dep IS_DEP=1; \
  88. else \
  89. echo "Error: No Makefile to build dependency $$dep." >&2; \
  90. exit 2; \
  91. fi \
  92. fi \
  93. done
  94. endif
  95. # Deps related targets.
  96. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  97. # While Makefile file could be GNUmakefile or makefile,
  98. # in practice only Makefile is needed so far.
  99. define dep_autopatch
  100. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  101. rm -rf $(DEPS_DIR)/$1/ebin/; \
  102. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  103. $(call dep_autopatch_erlang_mk,$(1)); \
  104. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  105. if [ -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  106. $(call dep_autopatch2,$1); \
  107. elif [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  108. $(call dep_autopatch2,$(1)); \
  109. elif [ 0 != `grep -ci "^[^#].*rebar" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  110. $(call dep_autopatch2,$(1)); \
  111. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i "^[^#].*rebar" '{}' \;`" ]; then \
  112. $(call dep_autopatch2,$(1)); \
  113. fi \
  114. else \
  115. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  116. $(call dep_autopatch_noop,$(1)); \
  117. else \
  118. $(call dep_autopatch2,$(1)); \
  119. fi \
  120. fi
  121. endef
  122. define dep_autopatch2
  123. ! test -f $(DEPS_DIR)/$1/ebin/$1.app || \
  124. mv -n $(DEPS_DIR)/$1/ebin/$1.app $(DEPS_DIR)/$1/src/$1.app.src; \
  125. rm -f $(DEPS_DIR)/$1/ebin/$1.app; \
  126. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  127. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  128. fi; \
  129. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  130. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script -o -f $(DEPS_DIR)/$1/rebar.lock ]; then \
  131. $(call dep_autopatch_fetch_rebar); \
  132. $(call dep_autopatch_rebar,$(1)); \
  133. else \
  134. $(call dep_autopatch_gen,$(1)); \
  135. fi
  136. endef
  137. define dep_autopatch_noop
  138. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  139. endef
  140. # Overwrite erlang.mk with the current file by default.
  141. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  142. define dep_autopatch_erlang_mk
  143. echo "include $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk" \
  144. > $(DEPS_DIR)/$1/erlang.mk
  145. endef
  146. else
  147. define dep_autopatch_erlang_mk
  148. :
  149. endef
  150. endif
  151. define dep_autopatch_gen
  152. printf "%s\n" \
  153. "ERLC_OPTS = +debug_info" \
  154. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  155. endef
  156. define dep_autopatch_fetch_rebar
  157. mkdir -p $(ERLANG_MK_TMP); \
  158. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  159. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  160. cd $(ERLANG_MK_TMP)/rebar; \
  161. git checkout -q 576e12171ab8d69b048b827b92aa65d067deea01; \
  162. $(MAKE); \
  163. cd -; \
  164. fi
  165. endef
  166. define dep_autopatch_rebar
  167. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  168. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  169. fi; \
  170. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  171. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  172. endef
  173. define dep_autopatch_rebar.erl
  174. application:load(rebar),
  175. application:set_env(rebar, log_level, debug),
  176. rmemo:start(),
  177. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  178. {ok, Conf0} -> Conf0;
  179. _ -> []
  180. end,
  181. {Conf, OsEnv} = fun() ->
  182. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  183. false -> {Conf1, []};
  184. true ->
  185. Bindings0 = erl_eval:new_bindings(),
  186. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  187. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  188. Before = os:getenv(),
  189. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  190. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  191. end
  192. end(),
  193. Write = fun (Text) ->
  194. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  195. end,
  196. Escape = fun (Text) ->
  197. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  198. end,
  199. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  200. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  201. Write("C_SRC_DIR = /path/do/not/exist\n"),
  202. Write("C_SRC_TYPE = rebar\n"),
  203. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  204. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  205. fun() ->
  206. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  207. case lists:keyfind(erl_opts, 1, Conf) of
  208. false -> ok;
  209. {_, ErlOpts} ->
  210. lists:foreach(fun
  211. ({d, D}) ->
  212. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  213. ({i, I}) ->
  214. Write(["ERLC_OPTS += -I ", I, "\n"]);
  215. ({platform_define, Regex, D}) ->
  216. case rebar_utils:is_arch(Regex) of
  217. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  218. false -> ok
  219. end;
  220. ({parse_transform, PT}) ->
  221. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  222. (_) -> ok
  223. end, ErlOpts)
  224. end,
  225. Write("\n")
  226. end(),
  227. fun() ->
  228. File = case lists:keyfind(deps, 1, Conf) of
  229. false -> [];
  230. {_, Deps} ->
  231. [begin case case Dep of
  232. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  233. {N, S} when is_tuple(S) -> {N, S};
  234. {N, _, S} -> {N, S};
  235. {N, _, S, _} -> {N, S};
  236. _ -> false
  237. end of
  238. false -> ok;
  239. {Name, Source} ->
  240. {Method, Repo, Commit} = case Source of
  241. {hex, V} -> {hex, V, undefined};
  242. {git, R} -> {git, R, master};
  243. {M, R, {branch, C}} -> {M, R, C};
  244. {M, R, {ref, C}} -> {M, R, C};
  245. {M, R, {tag, C}} -> {M, R, C};
  246. {M, R, C} -> {M, R, C}
  247. end,
  248. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  249. end end || Dep <- Deps]
  250. end
  251. end(),
  252. fun() ->
  253. case lists:keyfind(erl_first_files, 1, Conf) of
  254. false -> ok;
  255. {_, Files} ->
  256. Names = [[" ", case lists:reverse(F) of
  257. "lre." ++ Elif -> lists:reverse(Elif);
  258. Elif -> lists:reverse(Elif)
  259. end] || "src/" ++ F <- Files],
  260. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  261. end
  262. end(),
  263. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  264. Write("\npreprocess::\n"),
  265. Write("\npre-deps::\n"),
  266. Write("\npre-app::\n"),
  267. PatchHook = fun(Cmd) ->
  268. case Cmd of
  269. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  270. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  271. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  272. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  273. _ -> Escape(Cmd)
  274. end
  275. end,
  276. fun() ->
  277. case lists:keyfind(pre_hooks, 1, Conf) of
  278. false -> ok;
  279. {_, Hooks} ->
  280. [case H of
  281. {'get-deps', Cmd} ->
  282. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  283. {compile, Cmd} ->
  284. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  285. {Regex, compile, Cmd} ->
  286. case rebar_utils:is_arch(Regex) of
  287. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  288. false -> ok
  289. end;
  290. _ -> ok
  291. end || H <- Hooks]
  292. end
  293. end(),
  294. ShellToMk = fun(V) ->
  295. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  296. "-Werror\\\\b", "", [{return, list}, global])
  297. end,
  298. PortSpecs = fun() ->
  299. case lists:keyfind(port_specs, 1, Conf) of
  300. false ->
  301. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  302. false -> [];
  303. true ->
  304. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  305. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  306. end;
  307. {_, Specs} ->
  308. lists:flatten([case S of
  309. {Output, Input} -> {ShellToMk(Output), Input, []};
  310. {Regex, Output, Input} ->
  311. case rebar_utils:is_arch(Regex) of
  312. true -> {ShellToMk(Output), Input, []};
  313. false -> []
  314. end;
  315. {Regex, Output, Input, [{env, Env}]} ->
  316. case rebar_utils:is_arch(Regex) of
  317. true -> {ShellToMk(Output), Input, Env};
  318. false -> []
  319. end
  320. end || S <- Specs])
  321. end
  322. end(),
  323. PortSpecWrite = fun (Text) ->
  324. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  325. end,
  326. case PortSpecs of
  327. [] -> ok;
  328. _ ->
  329. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  330. PortSpecWrite(io_lib:format("ERL_CFLAGS ?= -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  331. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  332. PortSpecWrite(io_lib:format("ERL_LDFLAGS ?= -L \\"~s\\" -lerl_interface -lei\n",
  333. [code:lib_dir(erl_interface, lib)])),
  334. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  335. FilterEnv = fun(Env) ->
  336. lists:flatten([case E of
  337. {_, _} -> E;
  338. {Regex, K, V} ->
  339. case rebar_utils:is_arch(Regex) of
  340. true -> {K, V};
  341. false -> []
  342. end
  343. end || E <- Env])
  344. end,
  345. MergeEnv = fun(Env) ->
  346. lists:foldl(fun ({K, V}, Acc) ->
  347. case lists:keyfind(K, 1, Acc) of
  348. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  349. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  350. end
  351. end, [], Env)
  352. end,
  353. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  354. false -> [];
  355. {_, PortEnv0} -> FilterEnv(PortEnv0)
  356. end,
  357. PortSpec = fun ({Output, Input0, Env}) ->
  358. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  359. Input = [[" ", I] || I <- Input0],
  360. PortSpecWrite([
  361. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  362. case $(PLATFORM) of
  363. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  364. _ -> ""
  365. end,
  366. "\n\nall:: ", Output, "\n\n",
  367. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  368. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  369. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  370. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  371. [[Output, ": ", K, " += ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  372. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  373. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  374. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  375. case {filename:extension(Output), $(PLATFORM)} of
  376. {[], _} -> "\n";
  377. {_, darwin} -> "\n";
  378. _ -> " -shared\n"
  379. end])
  380. end,
  381. [PortSpec(S) || S <- PortSpecs]
  382. end,
  383. Write("\ninclude $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk"),
  384. RunPlugin = fun(Plugin, Step) ->
  385. case erlang:function_exported(Plugin, Step, 2) of
  386. false -> ok;
  387. true ->
  388. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  389. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  390. dict:store(base_dir, "", dict:new())}, undefined),
  391. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  392. end
  393. end,
  394. fun() ->
  395. case lists:keyfind(plugins, 1, Conf) of
  396. false -> ok;
  397. {_, Plugins} ->
  398. [begin
  399. case lists:keyfind(deps, 1, Conf) of
  400. false -> ok;
  401. {_, Deps} ->
  402. case lists:keyfind(P, 1, Deps) of
  403. false -> ok;
  404. _ ->
  405. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  406. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  407. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  408. code:add_patha(Path ++ "/ebin")
  409. end
  410. end
  411. end || P <- Plugins],
  412. [case code:load_file(P) of
  413. {module, P} -> ok;
  414. _ ->
  415. case lists:keyfind(plugin_dir, 1, Conf) of
  416. false -> ok;
  417. {_, PluginsDir} ->
  418. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  419. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  420. {module, P} = code:load_binary(P, ErlFile, Bin)
  421. end
  422. end || P <- Plugins],
  423. [RunPlugin(P, preprocess) || P <- Plugins],
  424. [RunPlugin(P, pre_compile) || P <- Plugins],
  425. [RunPlugin(P, compile) || P <- Plugins]
  426. end
  427. end(),
  428. halt()
  429. endef
  430. define dep_autopatch_appsrc_script.erl
  431. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  432. AppSrcScript = AppSrc ++ ".script",
  433. Bindings = erl_eval:new_bindings(),
  434. {ok, Conf} = file:script(AppSrcScript, Bindings),
  435. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  436. halt()
  437. endef
  438. define dep_autopatch_appsrc.erl
  439. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  440. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  441. case filelib:is_regular(AppSrcIn) of
  442. false -> ok;
  443. true ->
  444. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  445. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  446. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  447. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  448. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  449. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  450. end,
  451. halt()
  452. endef
  453. define dep_fetch_git
  454. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  455. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  456. endef
  457. define dep_fetch_git-submodule
  458. git submodule update --init -- $(DEPS_DIR)/$1;
  459. endef
  460. define dep_fetch_hg
  461. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  462. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  463. endef
  464. define dep_fetch_svn
  465. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  466. endef
  467. define dep_fetch_cp
  468. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  469. endef
  470. # Hex only has a package version. No need to look in the Erlang.mk packages.
  471. define dep_fetch_hex
  472. mkdir -p $(ERLANG_MK_TMP)/hex $(DEPS_DIR)/$1; \
  473. $(call core_http_get,$(ERLANG_MK_TMP)/hex/$1.tar,\
  474. https://s3.amazonaws.com/s3.hex.pm/tarballs/$1-$(strip $(word 2,$(dep_$1))).tar); \
  475. tar -xOf $(ERLANG_MK_TMP)/hex/$1.tar contents.tar.gz | tar -C $(DEPS_DIR)/$1 -xzf -;
  476. endef
  477. define dep_fetch_fail
  478. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  479. exit 78;
  480. endef
  481. # Kept for compatibility purposes with older Erlang.mk configuration.
  482. define dep_fetch_legacy
  483. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  484. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  485. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  486. endef
  487. define dep_fetch
  488. $(if $(dep_$(1)), \
  489. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  490. $(word 1,$(dep_$(1))), \
  491. $(if $(IS_DEP),legacy,fail)), \
  492. $(if $(filter $(1),$(PACKAGES)), \
  493. $(pkg_$(1)_fetch), \
  494. fail))
  495. endef
  496. define dep_target
  497. $(DEPS_DIR)/$(call dep_name,$1):
  498. $(eval DEP_NAME := $(call dep_name,$1))
  499. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  500. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  501. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)." >&2; \
  502. exit 17; \
  503. fi
  504. $(verbose) mkdir -p $(DEPS_DIR)
  505. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  506. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  507. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  508. echo " AUTO " $(1); \
  509. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  510. fi
  511. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  512. echo " CONF " $(DEP_STR); \
  513. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  514. fi
  515. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  516. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  517. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  518. echo " PATCH Downloading rabbitmq-codegen"; \
  519. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  520. fi; \
  521. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  522. echo " PATCH Downloading rabbitmq-server"; \
  523. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  524. fi; \
  525. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  526. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  527. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  528. echo " PATCH Downloading rabbitmq-codegen"; \
  529. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  530. fi \
  531. else \
  532. $$(call dep_autopatch,$(DEP_NAME)) \
  533. fi
  534. endif
  535. endef
  536. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  537. ifndef IS_APP
  538. clean:: clean-apps
  539. clean-apps:
  540. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  541. $(MAKE) -C $$dep clean IS_APP=1; \
  542. done
  543. distclean:: distclean-apps
  544. distclean-apps:
  545. $(verbose) set -e; for dep in $(ALL_APPS_DIRS) ; do \
  546. $(MAKE) -C $$dep distclean IS_APP=1; \
  547. done
  548. endif
  549. ifndef SKIP_DEPS
  550. distclean:: distclean-deps
  551. distclean-deps:
  552. $(gen_verbose) rm -rf $(DEPS_DIR)
  553. endif
  554. # Forward-declare variables used in core/deps-tools.mk. This is required
  555. # in case plugins use them.
  556. ERLANG_MK_RECURSIVE_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-deps-list.log
  557. ERLANG_MK_RECURSIVE_DOC_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-doc-deps-list.log
  558. ERLANG_MK_RECURSIVE_REL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-rel-deps-list.log
  559. ERLANG_MK_RECURSIVE_TEST_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-test-deps-list.log
  560. ERLANG_MK_RECURSIVE_SHELL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-shell-deps-list.log